<?php
/*function writeToLogFile($msg){
	$today = date("Y_m_d");
	$logfile = $today."_log.txt";
	$dir = 'logs';
	$saveLocation=$dir . '/' . $logfile;
	if  (!$handle = @fopen($saveLocation, "a")) {
		exit;
	} else {
		if (@fwrite($handle,"$msg\r\n") === FALSE) {
			exit;
		}
		 
		@fclose($handle);
	}
}*/

Class Car 
{
    var $ObjLogs;
    var $ObjTimeDate;
    var $DB;
    var $DB1;
    var $DB2;
    var $GPSTable;
    var $CarCoords;
    var $CarSpeed;
    var $CarTime;
    var $CarAzimuth;
	var $CarSattelites;
    var $CarRoutingImage;
	var $CarRoutingStartStopImage;
    var $CarImei;
    var $CarName;
    var $LostSignal;
    var $AddressCar;
    var $SensorValue;
    var $SensorType;
    var $SensorMeasure;
    //--
	var $CarTariff;
	var $CarEventId;
	var $CarEventDate;
	//--
	var $CarTimeSleep;
	var $CarEvent;
	//--
	var $CarEventTreker;
    var $CarEventNotSignal;
	//--
	var $StopParking;
	var $StopTime;
	var $CarNav;
	var $SensorSatelites;
	
	var $MurkerCluster;
	var $CurrentMonitoringMileage;
	var $CountOfStopsInMonitiring;
	var $LastStopAddressMonitiring;
	
    function Car($GPSTable)
    {
        include("settings.php");
        require_once("ClassMessageAndLogs.php");
        require_once("ClassTimeDate.php");
        include("ClassReport.php");
        
        include("ClassGeo.php");
        $this->ObjLogs=new MessageAndLogs();
        $this->ObjTimeDate=new TimeDate();
        $this->ObjReport = new Report('tms_gpsdata_fixed');        
        $this->DB = new mysqli ($DB_HOST,$DB_USER,$DB_PASS,$DB_NAME);
        $this->DB->query("SET CHARSET SET utf8");
        $this->DB->query("SET NAMES 'utf8'");
        $this->DB1 = new mysqli ($DB_HOST,$DB_USER,$DB_PASS,$DB_NAME);
        $this->DB1->query("SET CHARSET SET utf8");
        $this->DB1->query("SET NAMES 'utf8'");
        $this->DB2 = new mysqli ($DB_HOST,$DB_USER,$DB_PASS,$DB_NAME);
        $this->DB2->query("SET CHARSET SET utf8");
        $this->DB2->query("SET NAMES 'utf8'");
        $this->GPSTable=$GPSTable;
    }
	function GetMileageForMonitoring($Imei,$TimeFrom,$TimeTo) {
		$this->CurrentMonitoringMileage[] = $this->ObjReport->GetMileage3($Imei,$TimeFrom,$TimeTo);
	}
    
	function GetCountStops($Imei,$TimeFrom,$TimeTo) {
		$Query = "SELECT COUNT(id) FROM `tms_events` WHERE `DeviceLoginName`='$Imei' AND `date`>='$TimeFrom' 
		AND `date`<='$TimeTo' AND `EventType`=7";
		$Stmt = $this->DB->prepare($Query);
		$Stmt->execute();
		$Stmt->bind_result($count);
		$Stmt->fetch();
		$this->CountOfStopsInMonitiring[] = $count;
	}
	
	function GetLastStopAddressMonitiring($Imei,$TimeFrom,$TimeTo) {
		$Query = "SELECT `Addr`, `GeoX`, `GeoY`  FROM `tms_events` WHERE `DeviceLoginName`='$Imei' AND `date`>='$TimeFrom' 
		AND `date`<='$TimeTo' AND `EventType`=7 ORDER BY DATE DESC LIMIT 1 ";
		$Stmt = $this->DB->prepare($Query);
		$Stmt->execute();
		$Stmt->bind_result($address, $GoeX, $GeoY);
		$Stmt->fetch();
		//$address = '';
		 /* if (!$address) {
			//$address = GetGeolocationInnotech2($GoeX,$GeoY);
			if (!$address && $GoeX && $GeoY) {
				$address = $this->ObjReport->GetGeolocationYandexJSON($GoeX.'+'.$GeoY);
			}
		}  */
		$this->LastStopAddressMonitiring[] = $address;
	}
	
	function GetMovmentIngo($Imei) {
		
		$Query = "SELECT `Distance`, `CountParking`, `LastParking` FROM `wm_move_parking_info` WHERE `DeviceLoginName`='$Imei'";
		$Stmt = $this->DB->prepare($Query);
		$Stmt->execute();
		$Stmt->bind_result($Distance, $CountParking, $LastParking);
		$Stmt->fetch();
		$this->CountOfStopsInMonitiring[] = $CountParking;
		$this->LastStopAddressMonitiring[] = $LastParking;
		$this->CurrentMonitoringMileage[] = round($Distance/1000,0);
	}
	
	function GetStopParkingTAXI($imei,$fromtime,$currtime,$gmt)
	{
			//$Query = "SELECT ev.DeviceLoginName,ev.EventType,ADDTIME(ev.date,'0 ".$gmt.":0:0') FROM (SELECT e.DeviceLoginName,e.EventType,e.date FROM tms_events e WHERE e.date>='".$fromtime."' AND e.date<='". $currtime."' AND e.EventType IN (6,7,12) AND e.DeviceLoginName IN ('".$imei."') ORDER BY e.DeviceLoginName,e.date DESC) AS ev GROUP  BY ev.DeviceLoginName";
			$Query = "SELECT e.DeviceLoginName,e.EventType,ADDTIME(e.date,'0 ".$gmt.":0:0') FROM tms_events e WHERE e.date>='".$fromtime."' AND e.date<='". $currtime."' AND e.EventType IN (6,7,12) AND e.DeviceLoginName ='".$imei."' ORDER BY e.DeviceLoginName,e.date DESC LIMIT 1";
			//$this->ObjLogs->WriteLogAttendance("Method:GetStopParkingTAXI; ".$Query,'MonitoringLog','../logs'); 
			$Stmt = $this->DB->prepare($Query);
            $Stmt->execute();
            $Stmt->bind_result($imei, $eventtype, $ev_date);
            $r = $Stmt->fetch();
			//while ($Stmt->fetch()) 
            //{  
			if(!$r)
			{
				$this->StopParking[] = 0;
                $this->StopTime[] = '00:00:00';
			}
			else
			{
				$stop_time = '00:00:00';
				if ($eventtype==6 or $eventtype==7)
                {
                    $date1=strtotime($ev_date);
                    $date2=time();
                    $t=$date2-$date1;
                    $seconds =  $t%60;
                    $min = floor($t/60);
                    $minuts = $min%60;
                    $h = floor($min/60);
                    if ($h<10){$h='0'.$h;}
                    if ($minuts<10){$minuts='0'.$minuts;}
                    if ($seconds<10){$seconds='0'.$seconds;}
                    $this->StopTime[] = $h.':'.$minuts.':'.$seconds;
                } 
				$this->StopParking[] = $eventtype;
                $this->StopTime[] = $stop_time;
            }
            //}
			//$Stmt->close();
	}
	
	function GetInfoAboutMovementByTimeTAXI($Imei,$TimeFrom,$TimeTo,$time_signal,$gmt)
    {
        $Query = "SELECT latitude,longitude,speed,time,ADDTIME(time,'0 ".$gmt.":0:0'),azimuth,sattelites FROM ".$this->GPSTable." WHERE TIME>='".$TimeFrom."' AND TIME<='".$TimeTo."' AND DeviceLoginName='".$Imei."' ORDER BY TIME DESC LIMIT 1;";
		//$Query = "SELECT latitude,longitude,speed,time,ADDTIME(time,'0 ".$gmt.":0:0'),azimuth,sattelites FROM tms_gpsdata WHERE TIME>='".$TimeFrom."' AND TIME<='".$TimeTo."' AND DeviceLoginName='".$Imei."' ORDER BY TIME DESC LIMIT 1;";
        
		
		// for 12 ficha
		//$sImei = substr($Imei, 1);
		//$Query = "(SELECT latitude,longitude,speed,TIME,ADDTIME(TIME,'0 ".$gmt.":0:0'),azimuth,sattelites FROM tms_gpsdata_fixed WHERE TIME>='".$TimeFrom."' AND TIME<='".$TimeTo."' AND DeviceLoginName='".$Imei."' ORDER BY TIME DESC LIMIT 1) UNION (SELECT GeoY,GeoX,Speed,DrawdownDate,ADDTIME(DrawdownDate,'0 ".$gmt.":0:0'),Azimuth,LCASE(0) FROM imapdata WHERE DrawdownDate>='".$TimeFrom."' AND DrawdownDate<='".$TimeTo."' AND CallSign='".$Imei."' ORDER BY DrawdownDate DESC LIMIT 1)";
		
		//$this->ObjLogs->WriteLogAttendance("Method:GetInfoAboutMovementByTimeTAXI; ".$Query,'MonitoringLog','../logs'); 
		//$this->ObjLogs->WriteLogAttendance("Method:GetLastTimeByTime; Query:".$Query.' ; Imei:'.$Imei,'MonitoringLog','../logs');
		//writeToLogFile($Query);
		//$this->ObjLogs->WriteLogAttendance("Method: GetInfoAboutMovementByTimeTAXI : ".$Query,'MonitoringLog','../logs');
        
		$Stmt = $this->DB->prepare($Query);
        $Stmt->execute();
        $Stmt->bind_result($Latitude,$Longitude,$Speed,$Time,$TimeGMT,$Azimuth,$sattelites);
        $Stmt->fetch(); 
        $Stmt->close();
            
			$Coords=$Latitude.','.$Longitude;
            $this->CarCoords[]=$Coords;
            $this->CarSpeed[]=round($Speed);
            $this->CarTime[]=$Time;
            $this->CarAzimuth[]=$Azimuth;
			$this->CarSattelites[]=$sattelites;
			
			
			
			$Time_black=strtotime($TimeGMT);			
			$Time_black=time()-$Time_black;
            $Time_black=$Time_black/60;
			
			//$this->ObjLogs->WriteLogAttendance("Method: GetInfoAboutMovementByTimeTAXI Time: ".$TimeGMT." Time_black: ".$Time_black." time_signal: ".$time_signal,'MonitoringLog','../logs');
            
			if ($Time_black>$time_signal)
            {
				$this->CarEventTreker[] = 0;
				$this->CarEventNotSignal[] = date('Y-m-d H:i:s',$Time_black);
            }
            else
            {
				$this->CarEventTreker[] = 1;
            }
			//$Stmt->close();
    }
	
	function GetTariff($imei,$fromtime,$currtime,$gmt){
				//$query = "SELECT tariff,DeviceLoginName FROM (SELECT time,deviceloginname,eventid,tariff FROM gudwin_data WHERE time>='".$fromtime."' AND time<='".$currtime."' AND DeviceLoginName IN (".$imei.") ORDER BY time DESC) AS t GROUP BY DeviceLoginName";
                //$query = "SELECT deviceloginname,eventid,ADDTIME(TIME,'0 ".$gmt.":0:0'),tariff FROM (SELECT TIME,deviceloginname,eventid,tariff FROM gudwin_data WHERE TIME>='".$fromtime."' AND TIME<='".$currtime."' AND DeviceLoginName = '".$imei."' AND (eventid=5 OR eventid=6 OR eventid=1 OR eventid=2 OR eventid=3 OR eventid=14) ORDER BY TIME DESC) AS t GROUP BY deviceloginname";
				//$query = "SELECT deviceloginname,eventid,ADDTIME(TIME,'0 ".$gmt.":0:0'),tariff FROM (SELECT TIME,deviceloginname,eventid,tariff FROM gudwin_data WHERE TIME>='".$fromtime."' AND TIME<='".$currtime."' AND (eventid=5 OR eventid=6 OR eventid=1 OR eventid=2 OR eventid=3 OR eventid=14) AND DeviceLoginName IN ('".$imei."') ORDER BY TIME DESC) AS t GROUP BY deviceloginname";
				
				$query = "SELECT deviceloginname,eventid,ADDTIME(time,'0 ".$gmt.":0:0'),tariff,time FROM gudwin_data WHERE TIME>='".$fromtime."' AND TIME<='".$currtime."' AND (eventid=5 OR eventid=6 OR eventid=1 OR eventid=2 OR eventid=3 OR eventid=14) AND DeviceLoginName ='".$imei."' ORDER BY TIME DESC LIMIT 1";
				$this->ObjLogs->WriteLogAttendance("Method:GetTariff_1; ".$query,'MonitoringLog','../logs'); 
				if( $stmt = $this->DB->prepare($query) ){
				$stmt->execute();
				$stmt->bind_result($imei,$eventid,$date,$tariff,$time);
                
				$r = $stmt->fetch(); 
        
				//while ($stmt->fetch()) 
                if(!$r)
				{
						$this->CarTariff[]='Не Задан';
						$this->CarEventId[]=0;
						$this->CarEventDate[]=$fromtime;
						
						$T = strtotime($currtime) - (60*5);
						$T=date('Y-m-d H:i:s',$T);
						$d = $T;
				}
				else
				{
						if ($tariff==0) {$tariff='Не Задан';}
						$this->CarTariff[]=$tariff;
						$this->CarEventId[]=$eventid;
						$this->CarEventDate[]=$date;
						
						//$d = $time;
						$T = strtotime($time) - (60*5);
						$T=date('Y-m-d H:i:s',$T);
						$d = $T;
                }
				$stmt->close();
				}
				
				
				$os = array('1355','1357','1364','1354','1356','1358','1359','1360','1361','1362','1363','1365','1366','1367','1368','1369','1370');
				if (in_array($imei, $os)){
					$imei = substr($imei, 1);
				}
				
				$query = "SELECT DriverState FROM imapdata WHERE DrawdownDate >='".$d."' AND CallSign = '".$imei."' ORDER BY DrawdownDate DESC LIMIT 1";
				
				//$query = "SELECT DriverState FROM imapdata WHERE  RecordingDateInDB >=ADDTIME('".$fromtime."','0 ".$gmt.":0:0') AND RecordingDateInDB <=ADDTIME('".$currtime."','0 ".$gmt.":0:0') AND CallSign = '".$simei."' ORDER BY RecordingDateInDB DESC LIMIT 1";
				
				//$query = "SELECT DriverState FROM imapdata WHERE DrawdownDate >='".$fromtime."' AND DrawdownDate <='".$currtime."' AND CallSign = '".$imei."' ORDER BY DrawdownDate DESC LIMIT 1";
				
				$this->ObjLogs->WriteLogAttendance("Method:GetTariff_2; ".$query,'MonitoringLog','../logs'); 
				if( $stmt = $this->DB->prepare($query) ){
				$stmt->execute();
				$stmt->bind_result($DriverState);
				
				$this->ObjLogs->WriteLogAttendance("Method: GetTariff_2 state ; ".$DriverState." = ".$imei,'MonitoringLog','../logs'); 
				
				$r = $stmt->fetch(); 
                if(!$r)
				{
						$this->CarNav[] = null;
						$this->ObjLogs->WriteLogAttendance("Method: GetTariff_2 CarNav NULL ; ".$DriverState." = ".$imei,'MonitoringLog','../logs'); 
				}
				else
				{
						$this->CarNav[] = $DriverState;
						$this->ObjLogs->WriteLogAttendance("Method: GetTariff_2 CarNav DriverState ; ".$DriverState." = ".$imei,'MonitoringLog','../logs'); 
                }
				$stmt->close();
				}
    }
	
	function GetTariff2($imei,$fromtime,$currtime,$gmt){
				
    }
	
    function GetSensors($Imei, $fromTime, $toTime) {
    	
    	//$data = array();
    	$i = 0;
    	/* $query = "SELECT ds.`DevicePort` FROM `tms_device_sensor` ds
    	INNER JOIN `tms_device` d ON d.`ID`= ds.`DeviceId`
    	WHERE d.`Login` = '$Imei'"; */
    	$query = "SELECT ds.`DevicePort`, st.Name, st.measure FROM `tms_device_sensor` ds
		LEFT JOIN `tms_sensor_type` st ON st.ID = ds.`SensorTypeId`
    	INNER JOIN `tms_device` d ON d.`ID`= ds.`DeviceId`
    	WHERE d.`Login` = '$Imei'";
    	//$this->ObjLogs->WriteLogAttendance("GetSensors_1  ".$query,'MonitoringLog','../logs');
    	$stmt = $this->DB->prepare($query);
    	$stmt->execute();
    	$stmt->bind_result($ports, $sensorName, $measure);
    	while ($stmt->fetch()) {
    		$data[$i] = array(
    				'ports' => $ports,
    				'sensorName' => $sensorName,
    				'measure' => $measure,
    		);
    		$i++;
    	}
    	$stmt->close();
    	
    	
    	//foreach ($data as $SensorType) {
    	for ($i = 0; $i < count($data); $i++) {	
    		$query = "SELECT `sensorValue` FROM `tms_sensordata` WHERE `DeviceLoginName`='$Imei' AND `sensorType` =". $data[$i]['ports']."    		
    		AND `time`>='$fromTime' AND `time`<='$toTime' ORDER BY `time` DESC LIMIT 0,1";
    		//$this->ObjLogs->WriteLogAttendance("GetSensors_2  ".$query,'MonitoringLog','../logs');
    		$stmt = $this->DB->prepare($query);
    		$stmt->execute();
    		$stmt->bind_result($sensorValue);
    		if ($stmt->fetch()) {
    			if ($data[$i]['ports'] == 221) {
    				$this->SensorValue[$Imei][] = round($sensorValue, 2);
    			} else {
    				$this->SensorValue[$Imei][] = round($sensorValue, 0);
    			}    			
    			$this->SensorType[$Imei][] = $data[$i]['sensorName'];
    			$this->SensorMeasure[$Imei][] = $data[$i]['measure'];
    		}
    		$stmt->close();
    	} 
    	
    	/* $Query = "SELECT SensorType, MAX(`time`), sensorValue FROM tms_sensordata 
				WHERE DeviceLoginName='$Imei' AND TIME > SUBTIME(NOW(), '04:00:00')
				GROUP BY SensorType";
    	$Stmt = $this->DB->prepare($Query);    	
        $Stmt->execute();
        $Stmt->bind_result($SensorType, $time, $sensorValue); */
        
        /* while ($Stmt->fetch()) {
        	
        }
         */
    	
    	/* print_r($this->SensorValue);
    	print_r($this->SensorType);
    	exit; */
    	
        
    	
    }
    
    
    function GetSensorsByTime($Imei, $time) {
    	//$data = array();
    	$i = 0;
    	/* $query = "SELECT ds.`DevicePort` FROM `tms_device_sensor` ds
    	 INNER JOIN `tms_device` d ON d.`ID`= ds.`DeviceId`
    	WHERE d.`Login` = '$Imei'"; */
    	$query = "SELECT ds.`DevicePort`, st.Name, st.measure FROM `tms_device_sensor` ds
    	LEFT JOIN `tms_sensor_type` st ON st.ID = ds.`SensorTypeId`
    	INNER JOIN `tms_device` d ON d.`ID`= ds.`DeviceId`
    	WHERE d.`Login` = '$Imei'";
    	 
    	$stmt = $this->DB->prepare($query);
    	$stmt->execute();
    	$stmt->bind_result($ports, $sensorName, $measure);
    	while ($stmt->fetch()) {
    		$data[$i] = array(
    				'ports' => $ports,
    				'sensorName' => $sensorName,
    				'measure' => $measure,
    		);
    		$i++;
    	}
    	$stmt->close();
    	 
    	 
    	//foreach ($data as $SensorType) {
    	for ($i = 0; $i < count($data); $i++) {
    		$query = "SELECT `sensorValue` FROM `tms_sensordata` WHERE `DeviceLoginName`='$Imei' AND `sensorType` =". $data[$i]['ports']."
    		AND `time`='$time' ORDER BY `time` DESC LIMIT 0,1";
    		$this->ObjLogs->WriteLogAttendance("Query:".$query,'SensorLog','../logs');
    		$stmt = $this->DB->prepare($query);
    		$stmt->execute();
    		$stmt->bind_result($sensorValue);
    		if ($stmt->fetch()) {
    			if ($data[$i]['ports'] == 221) {
    				$this->SensorValue[$Imei][] = round($sensorValue, 2);
    			} else {
    				$this->SensorValue[$Imei][] = round($sensorValue, 0);
    			}    			
    			//$this->SensorValue[$Imei][] = round($sensorValue, 0);
    			$this->SensorType[$Imei][] = $data[$i]['sensorName'];
    			$this->SensorMeasure[$Imei][] = $data[$i]['measure'];
    		}
    		$stmt->close();
    	}
    	 
    	/* $Query = "SELECT SensorType, MAX(`time`), sensorValue FROM tms_sensordata
    	 WHERE DeviceLoginName='$Imei' AND TIME > SUBTIME(NOW(), '04:00:00')
    	GROUP BY SensorType";
    	$Stmt = $this->DB->prepare($Query);
    	$Stmt->execute();
    	$Stmt->bind_result($SensorType, $time, $sensorValue); */
    	
    	/* while ($Stmt->fetch()) {
    	 
    	}
    	 */
    	   
    	/* print_r($this->SensorValue);
    	 print_r($this->SensorType);
    	exit; */
    	 
    	$Query = "SELECT sattelites FROM ".$this->GPSTable." WHERE TIME>='".$time."' AND TIME<='".$time."' AND DeviceLoginName='".$Imei."' ORDER BY TIME DESC LIMIT 1;";
    	if( $stmt = $this->DB->prepare($Query)){
		$stmt->execute();
		$stmt->bind_result($sattelites);
		$stmt->fetch(); 
        $this->SensorSatelites[] = $sattelites;
		$stmt->close();
		}
		
    }
    
    function GetCarName($Imei)
    {
        $Query ="SELECT car_name FROM wm_car_info WHERE imei='".$Imei."'";
        //$this->ObjLogs->WriteLogAttendance("Method:GetCarName; Query:".$Query.' ; Imei:'.$Imei,'MonitoringLog','../logs');   
        $Stmt = $this->DB->prepare($Query);
        $Stmt->execute();       
        $Stmt->bind_result($CarName);
        $Stmt->fetch(); 
        $this->CarName[]=$CarName;
        
        return $CarName;
    }
    
    
    function GetLastCoordCars($Imei,$TimeFrom)
    {
        $Query = "SELECT latitude,longitude FROM ".$this->GPSTable." WHERE TIME<='".$TimeFrom."' AND DeviceLoginName='".$Imei."' ORDER BY TIME DESC LIMIT 1;";
        $Stmt = $this->DB->prepare($Query);
        $Stmt->execute();
        $Stmt->bind_result($Latitude,$Longitude);
        $Stmt->fetch(); 
        $Coords='('.$Latitude.','.$Longitude.')';
        $Stmt->close();
        $this->CarCoords[]=$Coords;
        return $Coords;
    }
    
    
    function GetLastSpeedCars($Imei,$TimeFrom)
    {
        $Query = "SELECT speed FROM ".$this->GPSTable." WHERE TIME<='".$TimeFrom."' AND DeviceLoginName='".$Imei."' ORDER BY TIME DESC LIMIT 1;";
        $Stmt = $this->DB->prepare($Query);
        $Stmt->execute();
        $Stmt->bind_result($Speed);
        $Stmt->fetch(); 
        $Stmt->close();
        $this->CarSpeed[] = round($Speed);
        return round($Speed);
    }
    
    
    function GetLastCoordCarsByTime($Imei,$TimeFrom,$TimeTo)
    {
        $Query = "SELECT latitude,longitude FROM ".$this->GPSTable." WHERE TIME>='".$TimeFrom."' AND TIME<='".$TimeTo."' AND DeviceLoginName='".$Imei."' ORDER BY TIME DESC LIMIT 1;";
        $Stmt = $this->DB->prepare($Query);
        $Stmt->execute();
        $Stmt->bind_result($Latitude,$Longitude);
        $Stmt->fetch(); 
        $Coords=$Latitude.','.$Longitude;
        $Stmt->close();
        $this->CarCoords[]=$Coords;
        return $Coords;        
    }
    
    
    function GetLastSpeedCarsByTime($Imei,$TimeFrom,$TimeTo)
    {
        $Query = "SELECT speed FROM ".$this->GPSTable." WHERE TIME>='".$TimeFrom."' AND TIME<='".$TimeTo."' AND DeviceLoginName='".$Imei."' ORDER BY TIME DESC LIMIT 1;";
        $Stmt = $this->DB->prepare($Query);
        $Stmt->execute();
        $Stmt->bind_result($Speed);
        $Stmt->fetch(); 
        $Stmt->close();
        $this->CarSpeed[] = round($Speed);
        return round($Speed);
    }
    
    
    function GetLastTimeByTime($Imei,$TimeFrom,$TimeTo)
    {
        $Query = "SELECT time FROM ".$this->GPSTable." WHERE TIME>='".$TimeFrom."' AND TIME<='".$TimeTo."' AND DeviceLoginName='".$Imei."' ORDER BY TIME DESC LIMIT 1;";
        //$this->ObjLogs->WriteLogAttendance("Method:GetLastTimeByTime; Query:".$Query.' ; Imei:'.$Imei,'MonitoringLog','../logs');
        $Stmt = $this->DB->prepare($Query);
        $Stmt->execute();
        $Stmt->bind_result($Time);
        $Stmt->fetch(); 
        $Stmt->close();
        $this->CarTime[]=$Time;
        return $Time;    
    }
    
    
    function GetLastAzimuthByTime($Imei,$TimeFrom,$TimeTo)
    {
        $Query = "SELECT azimuth FROM ".$this->GPSTable." WHERE TIME>='".$TimeFrom."' AND TIME<='".$TimeTo."' AND DeviceLoginName='".$Imei."' ORDER BY TIME DESC LIMIT 1;";
        $Stmt = $this->DB->prepare($Query);
        $Stmt->execute();
        $Stmt->bind_result($Azimuth);
        $Stmt->fetch(); 
        $Stmt->close();
        $this->CarAzimuth[]=$Azimuth;
        return $Azimuth;    
    }
    
    function GetInfoAboutMovementStart($Imei,$TimeFrom,$TimeTo)
    {
        $Query = "SELECT latitude,longitude,speed,time,azimuth,sattelites FROM ".$this->GPSTable." WHERE TIME>='".$TimeFrom."' AND TIME<='".$TimeTo."' AND DeviceLoginName='".$Imei."' ORDER BY TIME DESC LIMIT 1;";
       // $this->ObjLogs->WriteLogAttendance("Method:GetLastTimeByTime; Query:".$Query.' ; Imei:'.$Imei,'MonitoringLog','../logs');    
        $Stmt = $this->DB->prepare($Query);
        $Stmt->execute();
        $Stmt->bind_result($Latitude,$Longitude,$Speed,$Time,$Azimuth,$sattelites);
        $Stmt->fetch(); 
        $Stmt->close();
        $Coords=$Latitude.','.$Longitude;
        $this->CarCoords[]=$Coords;
        $this->CarSpeed[] = round($Speed);
        $this->CarTime[]=$Time;
        $this->CarAzimuth[]=$Azimuth;
		$this->CarSattelites[]=$sattelites; 
    }
    
    
    function GetInfoAboutMovementByTime($Imei,$TimeFrom,$TimeTo,$SessionCar,$gmt)
    {
        //$Query = "SELECT latitude,longitude,speed,time,azimuth,sattelites FROM ".$this->GPSTable." WHERE TIME>='".$TimeFrom."' AND TIME<='".$TimeTo."' AND DeviceLoginName='".$Imei."' ORDER BY TIME DESC LIMIT 1;";
        $Query = "SELECT latitude,longitude,speed,ADDTIME(time,'0 ".$gmt.":0:0'),azimuth,sattelites FROM ".$this->GPSTable." WHERE TIME>='".$TimeFrom."' AND TIME<='".$TimeTo."' AND DeviceLoginName='".$Imei."' ORDER BY TIME DESC LIMIT 1;";
		
		$this->ObjLogs->WriteLogAttendance("Method:GetInfoAboutMovementByTime; Query:".$Query.' ; Imei:'.$Imei,'MonitoringLog','../logs');
		//writeToLogFile($Query);	
        $Stmt = $this->DB->prepare($Query);
        $Stmt->execute();
        $Stmt->bind_result($Latitude,$Longitude,$Speed,$Time,$Azimuth,$sattelites);
        $Stmt->fetch(); 
        $Stmt->close();
		if (!$Time)
        {
            $this->CarCoords[]=$SessionCar['CarCoords'];
            $this->CarSpeed[]=$SessionCar['CarSpeed'];
            $this->CarTime[]=$SessionCar['CarTime'];
            $this->CarAzimuth[]=$SessionCar['CarAzimuth'];
			$this->CarSattelites[]=$SessionCar['CarSattelites'];
        }
        else
        {
            $Coords=$Latitude.','.$Longitude;
            $this->CarCoords[]=$Coords;
            $this->CarSpeed[]=round($Speed);
            $this->CarTime[]=$Time;
            $this->CarAzimuth[]=$Azimuth;
			$this->CarSattelites[]=$sattelites;	
        }
    }
	
	
    
    function CheckSignalGps($Time,$Duration)
    {
        $Time=strtotime($Time);
        $TimeDifferent=time()-$Time;
        $Hourse=$TimeDifferent/3600;
        $TimeNormal=$this->ObjTimeDate->DifferenceTime(date('Y-m-d H:i:s',time()),date( 'Y-m-d H:i:s',$Time));
        //$this->ObjLogs->WriteLogAttendance("Method:CheckSignalGps; Time:".$Time.' ; TimeDifferent:'.$TimeDifferent.' ; Hourse:'.$Hourse.' ; TimeNormal:'.$TimeNormal,'MonitoringLog','../logs'); 
        /*if ($Hourse>$Duration)
        {
           $this->LostSignal[]='images/Events/CoordsNotComeMedium.png';    
        }
        else
        {
           $this->LostSignal[]='';    
        } */
		if ($Hourse>$Duration)
        {
           $this->LostSignal[]='images/off.png';    
        }
        else
        {
           $this->LostSignal[]='images/on.png';    
        }
    }
    
    
    function GetCarDirection($Azimuth)
    {
        $Num=$Azimuth/10;
        $Num=floor($Num);  
        $Direction=$Num*10;
        return $Direction;
    }
    
    function GetGeolocation($list_of_imei_str,$client_id)
    {
        if ($client_id == 41)
        {
        $query="SELECT imei,adres_google,date FROM wm_adres WHERE imei IN (".$list_of_imei_str.")";
        $stmt1 = $this->DB->prepare($query);
        $stmt1->execute();
        $stmt1->bind_result($imei_adres,$adres_google,$date_adres);
        while ($stmt1->fetch()) 
        {
            $timeadres=date( 'Y-m-d H:i:s',time());
            $this->AddressCar[$imei_adres]=$adres_google;
            $date_adres=strtotime($date_adres);
            $date_adres=$date_adres+2*60*60;
            $date_adres=date( 'Y-m-d H:i:s',$date_adres);
                        //$maslat=explode("\t",$str[$imei_adres]);
            if ($date_adres<$timeadres)
            {
                $query="SELECT latitude,longitude FROM tms_gpsdata WHERE DeviceLoginName='".$imei_adres."' ORDER BY TIME DESC LIMIT 1";
                $stmt3 = $this->DB1->prepare($query);
                $stmt3->execute();
                $stmt3->bind_result($latitude_adres,$longitude_adres);
                while ($stmt3->fetch()) 
                {
                    $latitude_adres=$latitude_adres;
                    $longitude_adres=$longitude_adres;
                } 
                $address = $this->GetGeolocationGoogle($latitude_adres.','.$longitude_adres); 
                sleep(1);
                $query1="UPDATE wm_adres SET adres_google='".$address."', date='".$timeadres."'  WHERE imei='".$imei_adres."' ";
                $stmt2 = $this->DB2->prepare($query1);
                $stmt2->execute();             
                
                if ( $this->DB2->affected_rows == 0)
                {
                    $query1="INSERT INTO wm_adres (imei,adres_google,date) VALUES ( '".$imei_adres."','".$address."', '".$timeadres."' ";
                    $stmt2 = $this->DB2->prepare($query1);
                    $stmt2->execute();    
                }
            }
        }
    }
}
    
    function GetGeolocationGoogle($LatLng)
    {
            $DetailsUrl = "http://maps.googleapis.com/maps/api/geocode/json?latlng=".$LatLng."&sensor=true&language=ru";
            $CH = curl_init();
            curl_setopt($CH, CURLOPT_URL, $DetailsUrl);
            curl_setopt($CH, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($CH, CURLOPT_HEADER,0); //Change this to a 1 to return headers
            curl_setopt($CH, CURLOPT_USERAGENT, $_SERVER["HTTP_USER_AGENT"]);
            curl_setopt($CH, CURLOPT_FOLLOWLOCATION, 1);
            $Response = json_decode(curl_exec($CH), true);
            return $Response['results'][0]['formatted_address'];
    }
}
?>
