var TOiR_preventiv_Window = null;
var TOiR_preventiv_WindowAdd = null;
// var WindowFormPreventivNew = new Windows('Новый превентив',300,110,40,60,true);
   Ext.define('TOiR_PreventivModel', {
        extend: 'Ext.data.Model',
        fields: ['id_preventiv', 'name_preventiv']
    });

    var TOiR_PreventivStore = new Ext.data.Store(
      {
            autoLoad: true,
                // autoDestroy: true,
            model: 'TOiR_PreventivModel',
            proxy: 
            {
              type: 'ajax',
              url: 'app/TOiR_preventiv.php?func=show',
              reader: 
              {
                type: 'json',
                root: 'rows'
              }
            }
    });


function show_TOiR_preventiv_Window(Xcoord,Ycoord,Wwidth,Wheight){
    
    Xcoord = Xcoord ? Xcoord :40;
    Ycoord = Ycoord ? Ycoord :60;  
    Wwidth = Wwidth ? Wwidth :600;  
    Wheight = Wheight ? Wheight :400;

 

    PreventivGrid = Ext.create('Ext.grid.Panel',{
        selType: 'rowmodel',
        columnLines: true,
        id: 'TOiR_PreventivGridId',
        store: TOiR_PreventivStore,
        loadMask: true,
        border: false,
        autoScroll: true,
          dockedItems: [{
                xtype: 'toolbar',
                items: [{
                    //text: 'Добавить',
					text: all_toir.add,
                    iconCls: 'add',
                    handler: function(){
                        show_TOiR_preventiv_WindowAdd();
                    }
                    },
                    , '-', {
                    //text: 'Удалить',
					text: all_toir.del,
                    iconCls: 'delete',
                    handler: function() {
                        show_TOiR_preventiv_WindowRemove();
                    }
                    }
                ]
        }],
        columns:[
          {
            //text: 'Id Превентива', 
			text: prevent_toir.id_preventiv,
            dataIndex: 'id_preventiv',
            hideable: false,
            sortable: true,
            hidden:true
          },
          {
            //text: 'Превентив', 
			text: prevent_toir.preventiv,
            dataIndex: 'name_preventiv',
            flex:1,
            hideable: false,
            sortable: true
          }
        ]
    });

    if (!TOiR_preventiv_Window){
        Ext.getBody().mask(all.loading);
        TOiR_preventiv_Window = new Ext.Window({
            layout : 'fit',
            //title : 'Превентив',
			title : prevent_toir.preventiv,
            closeAction : 'destroy',
            width : parseInt(Wwidth),
            height : parseInt(Wheight),
            //minimizable: true,
            // constrainHeader: true,
            maximizable:true,
            // x: parseInt(Xcoord),
            // y: parseInt(Ycoord),
            listeners : {
                destroy : function(){
                    TOiR_preventiv_Window = null;   
                }
            },
            items : [PreventivGrid]
        });
        
    }
    function show_TOiR_preventiv_WindowAdd() {
        if (!TOiR_preventiv_WindowAdd) {
            TOiR_preventiv_WindowAdd = new Ext.Window({
                width: 300,
                height: 150,
                modal:true,
                //title: 'Новый превентив',
				title: prevent_toir.new_preventiv,
                closeAction: 'destroy',
                layout: 'fit',
                resizable: true,
                listeners : {
                    destroy : function(){
                    TOiR_preventiv_WindowAdd = null;    
                    }
                },
                items: [{
                    xtype: 'form',
                    autoScroll: true,
                    bodyPadding: '5 5 5 5',
                    id: "TOiR_PreventivFormId",
                    border: false,
                    frame: true,
                    autoHeight: true,
                    //fieldwidth:'width:150px',
                    //layout: 'anchor',
                    layout: {
                        type: 'vbox',
                        align: 'stretch'
                    },
                    // defaults: {
                    //     //fileUpload: true,
                    //     labelAlign: 'left',
                    //     labelWidth: 90,
                    //     //fieldWidth: '90%',
                    //     msgTarget: 'side'
                    // },
                    items: [
                {
                    xtype:'textfield',
                    //fieldLabel: 'Превентив',
					fieldLabel: prevent_toir.preventiv,
                    name : 'name_preventiv',
                    allowBlank: false
                }],
                buttons: [
                    {  // Набор кнопок. Здесь она всего одна.
                      //text: 'Добавить',
					  text: all_toir.add,
                      handler: function()
                        {
                          var form = this.up('form').getForm();
                              if(form.isValid())
                              {
                                form.submit(
                                {
                                  //waitMsg:'Идет отправка...',
								  waitMsg: all_toir.loading,
                                  url: 'app/TOiR_preventiv.php?func=add',
                                  params : {key : 'val', key2 : 'val2'},
                                  success: function(form,response) 
                                  {
                                    // Ext.Msg.alert('Внимание','Успешно добавлен'); 
                                    TOiR_preventiv_WindowAdd.destroy();
                                    Ext.getCmp('TOiR_PreventivGridId').store.load();
                                    Ext.getCmp('TOiR_PreventivGridId').getView().refresh();
                                  },
                                  failure : function()
                                  {
                                    Ext.Msg.alert(all_toir.attention, all_toir.error); 
                                  }
                                });
                              }else
                                {
                                  Ext.Msg.alert(all_toir.attention, all_toir.required_fields); 
                                }
                        }
                    },
                    {
                        //text: 'Отмена',
						text: all_toir.cancel,
                        handler: function()
                                  {
                                   TOiR_preventiv_WindowAdd.destroy();
                                  }
                      }
                    ] 
                }]
                 
            });
            TOiR_preventiv_WindowAdd.show();
        }
    }

    function show_TOiR_preventiv_WindowRemove() {   
      if (PreventivGrid) {
      var sm = PreventivGrid.getSelectionModel();
      var rs = sm.getSelection();
      if(!rs) return false;
      var id_preventiv = rs[0].get('id_preventiv');
      if (!rs.length) {
          Ext.Msg.alert(all_toir.attention, all_toir.select_row);
          return;
          }
            Ext.Msg.confirm(all_toir.attention, prevent_toir.are_you_sure_you_want_to_delete_the_selected_preventiv, function (button) {
              if (button == 'yes') {
                          Ext.Ajax.request({  
                              url : 'app/TOiR_preventiv.php?func=del',
                              method: 'GET',
                              params: {id_preventiv: id_preventiv}, 
                              success: function(objServerResponse){  
                                   }
                              });
                           PreventivGrid.store.remove(rs[0]);
                                    }
              });
            }    
    }
        
    TOiR_preventiv_Window.show();
    Ext.getBody().unmask(all.loading);
    
}