var TOiR_request_Window = null;
var TOiR_request_WindowAddEdit = null;
var TOiR_request_RequestInfoWindow = null;
var TOiR_request_BigImageWindow = null;
Ext.define('TOiR_RequestModel', {
    extend: 'Ext.data.Model',
    fields: ['id','job_type', 'workshop', 'client', 'outlet', 'region', 'sity', 'address',
	'contact_phone', 'contact_man', 'ID_PSD', 'client_number', 'description', 'outlet_type',
	'sales_man', 'status', 'worker', 'equipment', 'date_create', 'date_execut', 'work_duration','external_id']
});

var TOiR_requestStore = new Ext.data.Store(
  {
        //autoLoad: true,
		//autoDestroy: true,
	    pageSize: 50,
        model: 'TOiR_RequestModel',
        proxy: 
        {
          type: 'ajax',
          url: 'app/TOiR_request.php?func=show',
          reader: 
          {
            type: 'json',
            root: 'rows'
          }
        }
});

Ext.define('TOiR_JobTypeModel', {
    extend: 'Ext.data.Model',
    fields: ['id' , 'name']
});

var TOiR_JobTypeStoreRequest = new Ext.data.Store(
  {     autoLoad: true,
		//autoDestroy: true,
        model: 'TOiR_JobTypeModel',
        proxy: 
        {
          type: 'ajax',
          url: 'app/TOiR_request.php?func=showJobType',
          reader: 
          {
            type: 'json',
            root: 'rows'
          }
        }
});

Ext.define('TOiR_ClientModel', {
    extend: 'Ext.data.Model',
    fields: ['id' , 'name']
});

var TOiR_ClientStore = new Ext.data.Store(
  {     autoLoad: true,
		//autoDestroy: true,
        model: 'TOiR_ClientModel',
        proxy: 
        {
          type: 'ajax',
          url: 'app/TOiR_request.php?func=showClients',
          reader: 
          {
            type: 'json',
            root: 'rows'
          }
        }
});

Ext.define('TOiR_OutletsModel', {
    extend: 'Ext.data.Model',
    fields: ['id' , 'name']
});

var TOiR_OutletStoreRequest = new Ext.data.Store(
  {     
		//autoLoad: true,
		//autoDestroy: true,
        model: 'TOiR_OutletsModel',
        proxy: 
        {
          type: 'ajax',
          url: 'app/TOiR_request.php?func=showOutlets',
          reader: 
          {
            type: 'json',
            root: 'rows'
          }
        }
});

Ext.define('TOiR_EquipmentModel', {
    extend: 'Ext.data.Model',
    fields: ['id' , 'name']
});

var TOiR_EquipmentStoreRequest = new Ext.data.Store(
  {     
		//autoLoad: true,
		//autoDestroy: true,
        model: 'TOiR_EquipmentModel',
        proxy: 
        {
          type: 'ajax',
          url: 'app/TOiR_request.php?func=showEquipment',
          reader: 
          {
            type: 'json',
            root: 'rows'
          }
        }
});

Ext.define('TOiR_UsersRequestModel', {
    extend: 'Ext.data.Model',
    fields: ['id' , 'name']
});

var TOiR_UsersRequestStoreMy = new Ext.data.Store(
  {     
		//autoLoad: true,
		//autoDestroy: true,
        model: 'TOiR_UsersRequestModel',
        proxy: 
        {
          type: 'ajax',
          url: 'app/TOiR_request.php?func=showUsersRE',
          reader: 
          {
            type: 'json',
            root: 'rows'
          }
        }
});



function show_TOiR_request_Window(Xcoord,Ycoord,Wwidth,Wheight){
	TOiR_requestStore.load();
	closeRoute();
        Xcoord = Xcoord ? Xcoord :40;
        Ycoord = Ycoord ? Ycoord :60;  
        Wwidth = Wwidth ? Wwidth :1100;  
        Wheight = Wheight ? Wheight :400;
        
    var PagingToolbarTOiR_request = 	Ext.create('Ext.PagingToolbar', {
        //height:30,
        border: false,
        frame: false,
        store: TOiR_requestStore,
        displayInfo: true
    });
    	     
		
    if (!TOiR_request_Window){
        Ext.getBody().mask(all.loading);
        TOiR_request_Window = new Ext.Window({
            layout : 'fit',
            //title : 'Заявки',
			title : TOiR.request,
            closeAction : 'destroy',
            width : parseInt(Wwidth),
            height : parseInt(Wheight),
            //minimizable: true,
			constrainHeader: true,
            maximizable:true,
            //x : parseInt(Xcoord),
            //y : parseInt(Ycoord),
			listeners : {
            	destroy : function(){
					TOiR_request_Window = null;	
            	}
            },
            items : [
			
new Ext.create('Ext.grid.Panel',{
    selType: 'rowmodel',
    columnLines: true,
    id: 'TOiR_RequestGridId',
    store: TOiR_requestStore,
    loadMask: true,
    border: false,
    autoScroll: true,
	dockedItems: [{
            xtype: 'toolbar',
            items: [{
                //text: 'Добавить',
				text: all_toir.add,
                iconCls: 'add',
                handler: function(){
					//show_TOiR_users_WindowAddEdit(false);
					show_TOiR_request_WindowAddEdit();
				}
				},'-',{
                //text: 'Удалить',
				text: all_toir.del,
                iconCls: 'delete',
                handler: function(){
							var select = Ext.getCmp('TOiR_RequestGridId').getView().getSelectionModel().getSelection()[0];
                            if (select) {
                                Ext.MessageBox.confirm(all_toir.attention, request_toir.are_you_sure_you_want_to_delete_the_record, function(btn) {
                                    if (btn == 'yes') {
                                        //alert(select.get('id'));
                                        Ext.Ajax.request({
                                            url: 'app/TOiR_request.php',
                                            method: 'POST',
                                            params: { 'func':'delete', "id": select.get('id')},
                                            success: function(response) {
                                                Ext.MessageBox.alert(all_toir.skill, all_toir.record_deleted_successfully);
                                                Ext.getCmp('TOiR_RequestGridId').store.load();
												Ext.getCmp('TOiR_RequestGridId').getView().refresh();
                                            }/*,
                                            failure: function(response) {
                                                Ext.MessageBox.alert('Помилка', response.responseText);
                                            }*/
                                        });
                                    }
                                });
                            } else {
                                Ext.MessageBox.alert(all_toir.error, all_toir.select_row);
                            }
				}
				},'-',{
                //text: 'Редактировать',
				text: all_toir.edit,
                iconCls: 'edit',
                handler: function(){
                	//if () {
                		var select = Ext.getCmp('TOiR_RequestGridId').getView().getSelectionModel().getSelection()[0];
                        if (select) {
    						//show_TOiR_users_WindowAddEdit(select.get('id'));
                        	console.log(select);
                        	isLocked(select);
    					} else {
                            Ext.MessageBox.alert(all_toir.error, all_toir.select_row);
                        }
                	//}
					
				}
				},'->', {
 					xtype: 'textfield',
 					width: 150,
 					id: 'request_filter_field_id'
 				},'-',{
 					//text: 'Фильтровать',
					text: all_toir.filter,
 					handler: function () {
 						var filter = Ext.getCmp('request_filter_field_id').getValue(); 					
 						TOiR_requestStore.setProxy({
 							type: 'ajax',
 					          url: 'app/TOiR_request.php?func=show&filter='+filter,
 					          reader: 
 					          {
 					            type: 'json',
 					            root: 'rows'
 					          }
 						});
 						TOiR_requestStore.load();
 						TOiR_requestStore.loadPage(1); 						
 					}
 					
 				},'-', {
 					//text: 'Очистить',
					text: all_toir.filter_reset,
 					margin: '0 20 0 0',
 					handler: function () {
 						Ext.getCmp('request_filter_field_id').setValue('');
 						TOiR_requestStore.setProxy({
 							type: 'ajax',
 					          url: 'app/TOiR_request.php?func=show',
 					          reader: 
 					          {
 					            type: 'json',
 					            root: 'rows'
 					          }
 						});
 						TOiR_requestStore.load();
 						TOiR_requestStore.loadPage(1); 						
 					}
 				}
			]
	}],
    columns:[
      {
    	  text: 'ID', 
          dataIndex: 'id',
          sortable: true,
          style: 'text-align:center',            
          align: 'center',
          width: 50
      },       
      {
        //text: 'Тип работы', 
		text: plan_toir.type_of_works,
        dataIndex: 'job_type',
        sortable: true
      },
      {
        //text: 'Мастерская', 
		text: request_toir.workshop, 
        dataIndex: 'workshop',
        hideable: false,
        sortable: true
      },
      {
        //text: 'Клиент', 
		text: client_toir.client,
        dataIndex: 'client',
        sortable: true
      },
      {
        //text: 'Название ТТ', 
		text: request_toir.name_TT, 
        dataIndex: 'outlet',
        sortable: true
      },	 
      {
        //text: 'Область', 
		text: client_toir.domain, 
        dataIndex: 'region',
        sortable: true
      },
      {
        //text: 'Город', 
		text: client_toir.sity, 
        dataIndex: 'sity',
        sortable: true
      },
      {
        //text: 'Адрес', 
		text: client_toir.address, 
        dataIndex: 'address',
        sortable: true
      },
	  /*{
        text: 'Контактный телефон', 
        dataIndex: 'contact_phone',
        sortable: true
      },*/
	  {
        //text: 'Контактное лицо', 
		text: client_toir.contact_person, 
        dataIndex: 'contact_man',
        sortable: true
      },
	  /*{
        text: 'ID код PS&D', 
        dataIndex: 'ID_PSD',
        sortable: true
      },*/
	  {
        //text: 'Номер контракта', 
		text: client_toir.contract_number, 
        dataIndex: 'client_number',
        sortable: true
      },	 
	  /*{
        text: 'Примечание', 
        dataIndex: 'description',
        sortable: true
      },*/
	  {
        //text: 'Тип ТТ', 
		text: request_toir.type_TT, 
        dataIndex: 'outlet_type',
        sortable: true
      },
	  {
        //text: 'Телефон ТП', 
		text: request_toir.phone_TP, 
        dataIndex: 'sales_man',
        sortable: true
      },
	  {
        //text: 'Статус', 
		text: plan_toir.status, 
        dataIndex: 'status',
        sortable: true
      },
	  {
        //text: 'Имя мастера', 
		text: request_toir.name_master, 
        dataIndex: 'worker',
        sortable: true
      },
	  {
        //text: 'Оборудования', 
		text: request_toir.equipment, 
        dataIndex: 'equipment',
        sortable: true
      },
      {
    	  //text: 'Время работ, мин', 
		  text: request_toir.time_min, 
          dataIndex: 'work_duration',
          sortable: true    	    
      },
	  {
        //text: 'Создана/изменена', 
		text: request_toir.create_edit, 
        dataIndex: 'date_create',
        sortable: true
      },
	  {
        //text: 'Время визита', 
		text: request_toir.visit_time,
        dataIndex: 'date_execut',
        sortable: true
      },
      {    	 
    	  //text: 'Внешний ID', 
		  text: request_toir.external_ID, 
          dataIndex: 'external_id',
          sortable: true
      }
    ],
    bbar:[PagingToolbarTOiR_request],
    listeners: {
    	itemdblclick: function(cmp, records) {    		
    		//isLocked(records); 
    		//show_TOiR_request_WindowAddEdit(records.get('id'));
    		showInfoAboutRequest(records);
    		
    	}
    }
})
			]
        });
        
    }
    
    TOiR_request_Window.show();
    Ext.getBody().unmask(all.loading);
	
}


function show_TOiR_request_WindowAddEdit(id, isLock) {
	TOiR_UsersRequestStoreMy.load();
	//TOiR_RolesStore.load();
	
	if (!id){
        //var t = calendar.adding_tasks;
		//var title = "Добавить заявку";
		var title = request_toir.add_the_request;
		var isLock = false;
		var isTTLock = true;
        //var func = 'add';
    }else{
        //var t = calendar.editing_tasks;
		//var title = "Редактировать заявку";
		var title = request_toir.edit_the_request;
		var isTTLock = isLock;		
        //var func = 'edit';
    }
	var date = new Date();
	console.log(date);
	
	if(!TOiR_request_WindowAddEdit){
         var TOiR_request_WindowAddEdit = new Ext.Window({
                        width:800,
                        height:500,
                        title: title,
                        closeAction : 'destroy',
						listeners : {
							destroy : function(){
								TOiR_request_WindowAddEdit = null;	
							}
						},
                        layout:'fit',
                        resizable: true,
						constrainHeader: true,
                        modal:true,
                        items:[
						{
						xtype: 'form',
						autoScroll: true,
						bodyPadding: '5 5 5 5',
						id: "TOiR_RequestFormId",
						border: false,
						frame: true,
						autoHeight: true,
						//fieldwidth:'width:150px',
						layout: {
							type: 'table',
							columns: 2
							//align: 'stretch'
						},
						defaults: {
							//fileUpload: true,
							//labelAlign: 'left',
							labelWidth: 120,
							msgTarget: 'side',
							margin: '5 5 5 5',
							width: 350,
							
						},
						items:[
	
						{
							xtype: 'combo',
							//fieldLabel: 'Тип работ',
							fieldLabel: plan_toir.type_of_works,
							disabled: isLock,
							store: TOiR_JobTypeStoreRequest,
							valueField: 'id',
							displayField: 'name',
							name : 'job_type',
							editable: false,
							allowBlank: false,
						},
						{
							xtype: 'combo',
							//fieldLabel: 'Клиент',
							fieldLabel: client_toir.client,
							disabled: isLock,
							store: TOiR_ClientStore,
							valueField: 'id',
							displayField: 'name',
							name : 'client',
							editable: false,
							allowBlank: false,
							listeners: {
								select: function(combo, record) {
									var clientID = record[0].get('id');
									TOiR_OutletStoreRequest.load({
										params: {
											clientID: clientID
										}
									});
									/*TOiR_EquipmentStore.load({
										params: {
											clientID: clientID
										}
									});*/
									Ext.getCmp('outlet_combo_id').enable(true);
								}
							}
						},
						{
							xtype: 'combo',
							//fieldLabel: 'Название ТТ',
							fieldLabel: request_toir.name_TT,
							disabled: isLock,
							store: TOiR_OutletStoreRequest,
							valueField: 'id',
							displayField: 'name',
							id: 'outlet_combo_id',
							name : 'outlet',
							editable: false,
							disabled: true,
							allowBlank: false,
							listeners: {
								select: function(combo, record) {
									var id = record[0].get('id');
									Ext.getCmp('equipment_combo_id').enable(true);
									TOiR_EquipmentStoreRequest.load({
										params: {
											outletID: id
										}
									});								
									Ext.getCmp('request_id_region').enable(true);
									Ext.getCmp('request_id_sity').enable(true);
									Ext.getCmp('request_id_address').enable(true);
									Ext.getCmp('request_id_contact_man').enable(true);
									Ext.getCmp('request_id_client_number').enable(true);
									Ext.getCmp('request_id_outlet_type').enable(true);
									Ext.getCmp('request_id_sales_man').enable(true);
								
									
									request_id_sity
									Ext.Ajax.request({
										url: 'app/TOiR_request.php',
										method: 'POST',
										params: {'func':'getOutletsData', 'id':id},
										success: function(response) {
											var dataObj = Ext.decode(response.responseText);
											Ext.getCmp('request_id_region').setValue(dataObj.region);
											Ext.getCmp('request_id_sity').setValue(dataObj.sity);
											Ext.getCmp('request_id_address').setValue(dataObj.address);
											Ext.getCmp('request_id_contact_phone').setValue(dataObj.contact_phone);
											Ext.getCmp('request_id_contact_man').setValue(dataObj.contact_man);
											Ext.getCmp('request_id_ID_PSD').setValue(dataObj.ID_PSD);
											Ext.getCmp('request_id_client_number').setValue(dataObj.client_number);
											Ext.getCmp('request_id_description').setValue(dataObj.description);
											Ext.getCmp('request_id_outlet_type').setValue(dataObj.outlet_type);
											Ext.getCmp('request_id_sales_man').setValue(dataObj.sales_man);
											
										}										
									});
								}
							}
						},
						{
							xtype: 'textfield',
							//fieldLabel: 'Область',
							fieldLabel: client_toir.domain,
							disabled: isTTLock,
							name : 'region',
							id: 'request_id_region',							
							allowBlank: false,
						},
						{
							xtype: 'textfield',
							//fieldLabel: 'Город',
							fieldLabel: client_toir.sity,
							disabled: isTTLock,
							allowBlank: false,
							name : 'sity',
							id: 'request_id_sity'
						},
						{
							xtype: 'textfield',
							//fieldLabel: 'Адрес',
							fieldLabel: client_toir.address,
							disabled: isTTLock,
							name : 'address',							
							allowBlank: false,
							id: 'request_id_address'
						},
						{
							xtype: 'textfield',
							//fieldLabel: 'Контактный телефон',
							fieldLabel: client_toir.contact_phone,
							disabled: isTTLock,
							name : 'contact_phone',
							allowBlank: true,
							hidden: true,
							id: 'request_id_contact_phone'
						},
						{
							xtype: 'textfield',
							//fieldLabel: 'Контактное лицо',
							fieldLabel: client_toir.contact_person,
							disabled: isTTLock,
							name : 'contact_man',
							allowBlank: false,
							id: 'request_id_contact_man'
						},
						{
							xtype: 'textfield',
							fieldLabel: 'ID код PS&D',
							disabled: isTTLock,
							allowBlank: true,
							hidden: true,
							name : 'ID_PSD',
							id: 'request_id_ID_PSD'
						},						
						{
							xtype: 'textfield',
							//fieldLabel: 'Номер контакта',
							fieldLabel: client_toir.contract_number,
							disabled: isTTLock,
							allowBlank: false,
							name : 'client_number',
							id: 'request_id_client_number'
						},
						{
							xtype: 'textfield',
							fieldLabel: 'Примечания',
							disabled: isTTLock,
							allowBlank: true,
							hidden: true,
							name : 'description',
							id: 'request_id_description',
						},
						{
							xtype: 'textfield',
							//fieldLabel: 'Тип ТТ',
							fieldLabel: request_toir.type_TT,
							disabled: isTTLock,
							allowBlank: false,
							name : 'outlet_type',
							id: 'request_id_outlet_type'
						},
						{
							xtype: 'textfield',
							//fieldLabel: 'Телефон торгового представителя',
							fieldLabel: client_toir.telephone_sales_representative,
							disabled: isTTLock,
							name : 'sales_man',
							allowBlank: false,
							id: 'request_id_sales_man'
						},
						{
							xtype: 'combo',
							//fieldLabel: 'Мастер',
							fieldLabel: request_toir.name_master,
							name : 'worker',
							disabled: isLock,
							store: TOiR_UsersRequestStoreMy,
							valueField: 'id',
							displayField: 'name',
							queryMode: 'local',
							value: 0
						},
						{
							xtype: 'checkbox',
							//fieldLabel: 'Мастерская',
							fieldLabel: request_toir.workshop,
							disabled: isLock,
							name : 'workshop',
							inputValue: 1
						},
						{
							xtype: 'checkbox',
							disabled: isLock,
							//fieldLabel: 'Заявка выполнена',
							fieldLabel: request_toir.request_executed,
							name : 'status',
							inputValue: 1
						},						
						{
							xtype: 'combo',
							//fieldLabel: 'Оборудование',
							fieldLabel: TOiR.Equipment,
							disabled: isLock,
							allowBlank: false,
							id: 'equipment_combo_id',
							name : 'equipment',
							store: TOiR_EquipmentStoreRequest,
							valueField: 'id',
							disabled: true,
							displayField: 'name',
							queryMode: 'local',
							listeners: {
								select: function(combo, record) {
									var clientID = record[0].get('id');
									TOiR_OutletStore.load({
										params: {
											clientID: clientID
										}
									});
								}
							}
						},						
						{
							xtype: 'datefield',
							disabled: isLock,
							//fieldLabel: 'Дата создания',
							fieldLabel: request_toir.date_of_creation,
							format: 'Y-m-d H:i:s',
							altFormats: 'Y-m-d H:i:s',
							startDay: 1,
							name : 'date_create',
							id: 'date_create_id',
							value: new Date(),
							listeners: { 
								change: function(newValue, oldValue, eOpts){ 
									Ext.getCmp('date_execute_id').setMinValue( this.getValue() )
									Ext.getCmp('date_execute_id').setValue( this.getValue() )
								}
							}							
						},
						{
							xtype: 'datefield',
							disabled: isLock,
							//fieldLabel: 'Дата визита',
							fieldLabel: request_toir.date_of_visit,
							allowBlank: false,
							//format: 'Y-m-d H:i:s',
							//altFormats: 'Y-m-d H:i:s',
							format: 'Y-m-d',
							altFormats: 'Y-m-d',
							startDay: 1,
							name : 'date_execut',
							id: 'date_execute_id',
							//value: new Date(date.setDate(date.getDate() + 1)),
							value: new Date(), 
							minValue: new Date(),						
						}, {
							xtype: 'textfield',
							name: 'work_duration',
							disabled: isLock,
							allowBlank: false,
							//fieldLabel: 'Время выполнения, мин',
							fieldLabel: request_toir.run_time_min,
						}, {
							xtype: 'textfield',
							name: 'external_id',
							//fieldLabel: 'Внешний ID'
							fieldLabel: request_toir.external_ID
						}
						/*{
                          xtype:'textfield',
                          fieldLabel: 'Имя пользователя',
                          allowBlank: false,
						  name : 'name'
                        },
                        {
                          xtype:'textfield',
                          fieldLabel: 'Пароль',
						  allowBlank: false,
                          name : 'password'
                        },
                        {
                          xtype:'combo',
                          fieldLabel: 'Роль',
						  allowBlank: false,
						  store: TOiR_RolesStore,
						  queryMode: 'local',
						  displayField: 'type',
						  valueField: 'id',
						  typeAhead: false,
						  triggerAction: 'all',
						  lazyRender: true,
						  editable: false,
                          name : 'id_role'
                        },
                        {
                          xtype:'textfield',
                          fieldLabel: 'Телефон',
                          name : 'tel'
                        },
                        {
                          xtype:'textfield',
                          fieldLabel: 'E-mail',
                          name : 'email'
                        },
                        {
                          xtype:'textfield',
                          fieldLabel: 'Должность',
                          name : 'post'
                        },
                        {
                          xtype:'textfield',
                          fieldLabel: 'Департамент',
                          name : 'department'
                        }*/
						],buttons:[
							{ 
							//text:'Cохранить',
							text: all_toir.save,
							disabled: isLock,
							//id:'buttonUploads',
							iconCls:'save',
							handler: function() {
								console.log(id);
								var form = this.up('form').getForm();
								var time = Ext.getCmp('date_execute_id').getRawValue();
								if(form.isValid()){
								form.submit({
									//waitMsg:'Идет отправка...',
									waitMsg: all_toir.loading,
                                    url: 'app/TOiR_request.php',
									//waitMsg: 'Збереження...',
									wait: true,
									scope: this,
									method: 'post',
									//timeout : 60000,
									params: {func:'addedit',id:id},
                                    success: function(fp, o){
                                       /* console.log(o);
										if(o.result.success == true){
											Ext.Msg.alert('Выполнено','Успешно добавлен'); 
											TOiR_users_WindowAddEdit.destroy();
											Ext.getCmp('TOiR_UserGridId').store.load();
											Ext.getCmp('TOiR_UserGridId').getView().refresh();
										}else{
											Ext.MessageBox.alert('Ошибка', o.result.message);
										}*/
                                    	
                                    	TOiR_request_WindowAddEdit.destroy();
                                    	
                                    	Ext.getCmp('TOiR_RequestGridId').store.load();
										Ext.getCmp('TOiR_RequestGridId').getView().refresh();
										if (Ext.getCmp('TOiR_TripPlanningGridId')) {
											Ext.getCmp('TOiR_TripPlanningGridId').store.load({
									  			params: {
									  				time: time
									  			}
									  		});
											Ext.getCmp('TOiR_TripPlanningGridId').getView().refresh();
											clearMap();
										}
										
                                    	
                                    }/*,
									failure: function(fp, o){
										 console.log(o);
										Ext.MessageBox.alert('Ошибка', o.result.message);
									}*/
								});
							}
							}
							},
							{
                            //text: 'Отмена',
							text: all_toir.cancel,
							iconCls:'cancel',
                            handler: function(){
                                TOiR_request_WindowAddEdit.destroy();
                            }
							}
						]
						}
						]
		});
	}
	TOiR_request_WindowAddEdit.show();
	
	var form = Ext.getCmp("TOiR_RequestFormId").getForm().getFields();
    if (id) {
    	Ext.getCmp('equipment_combo_id').enable(true);
    	Ext.getCmp('outlet_combo_id').enable(true);
        Ext.Ajax.request({
            url: 'app/TOiR_request.php',
            method: 'POST',
            params: {"func":"editshow","id":id},
            success: function(response) {
                var JSON = response.responseText;
                if (JSON) {
                    var decoded = Ext.decode(JSON);
					var i = 0;					
					var arrOfItems = [];
					for (k in decoded) {
						arrOfItems.push(decoded[k]);
					}
					console.log(arrOfItems);
					form.each(function(item) {						
						if (i == 1) {
							TOiR_OutletStoreRequest.load({
								params: {
									clientID: arrOfItems[i]
								}
							});
						}	
						if (i == 2) {
						TOiR_EquipmentStoreRequest.load({
								params: {
									outletID: arrOfItems[i]
								}
							});
						}
						
						
					if (item.xtype == 'combo') {
                        //item.setRawValue(decoded[i]);
						item.setValue(parseInt(arrOfItems[i]));
                    } else {
						if (i == 18) {
							var arr = arrOfItems[i].split(' ');
							console.log(arr[0]);
							item.setValue(arr[0]);
						} else {
							item.setValue(arrOfItems[i]);
						}
					}
					i++;
                    });
                }
            },
            failure: function(response) {
                Ext.MessageBox.alert(all_toir.error, response.responseText);
            }
        });
    }
} 

function isLocked(select) {
	$.post('app/TOiR_request.php', {func: 'isLocked', id_request: select.get('id')}, function(data){		
		console.log(data);
		if (parseInt(data)) {			
			show_TOiR_request_WindowAddEdit(select.get('id'), true);
			Ext.getCmp('equipment_combo_id').disable(true);
			Ext.getCmp('outlet_combo_id').disable(true);
			Ext.Msg.alert(all_toir.attention, request_toir.request_for_unclassified_route_is_only_available_for_viewing_editing_is_forbidden);
		} else {
			show_TOiR_request_WindowAddEdit(select.get('id'));
		}
	});
}

function closeRoute () {
	$.post('app/TOiR_request.php', {func: 'closeRoute'}, function(data) {
		
	});
}
Ext.define('TOiR_RequestInfoModel', {
    extend: 'Ext.data.Model',
    fields: ['id_request', 'id_result_job', 'comment','possible_fault', 'conclution_master', 'id_preventive']
});
var TOiR_RequestInfoJobStore = new Ext.data.Store(
		  {     
			   //autoLoad: true,
				//autoDestroy: true,
		        model: 'TOiR_RequestInfoModel',
		        proxy: 
		        {
		          type: 'ajax',
		          url: 'app/TOiR_request.php?func=showJobInfo',
		          reader: 
		          {
		            type: 'json',
		            root: 'rows'
		          }
		        }
});

Ext.define('TOiR_RequestConfirmationModel', {
    extend: 'Ext.data.Model',
    fields: ['id_request', 'name_client', 'post_client', 'signature_client', 'signature_master','foto', 'signature_client_img',
             'signature_master_img', 'foto_img']
});
var TOiR_RequestInfoConfirmationStore = new Ext.data.Store(
		  {     
			   //autoLoad: true,
				//autoDestroy: true,
		        model: 'TOiR_RequestConfirmationModel',
		        proxy: 
		        {
		          type: 'ajax',
		          url: 'app/TOiR_request.php?func=showConfirmation',
		          reader: 
		          {
		            type: 'json',
		            root: 'rows'
		          }
		        }
});

Ext.define('TOiR_RequestEquipmentModel', {
    extend: 'Ext.data.Model',
    fields: ['id_equipment', 'count', 'actual_number', 'actual_model', 'changeTime', 'model']
});
var TOiR_RequestInfoEquipmentStore = new Ext.data.Store(
		  {     
			   //autoLoad: true,
				//autoDestroy: true,
		        model: 'TOiR_RequestEquipmentModel',
		        proxy: 
		        {
		          type: 'ajax',
		          url: 'app/TOiR_request.php?func=showInfoEquipment',
		          reader: 
		          {
		            type: 'json',
		            root: 'rows'
		          }
		        }
});


Ext.define('TOiR_RequestUsedSparesModel', {
    extend: 'Ext.data.Model',
    fields: ['id', 'request_id','spares_group', 'name', 'article', 'count', 'insert_time', 'mobile_time_change']
});
var TOiR_RequestInfoUsedSparesStore = new Ext.data.Store(
		  {     
			   //autoLoad: true,
				//autoDestroy: true,
		        model: 'TOiR_RequestUsedSparesModel',
		        proxy: 
		        {
		          type: 'ajax',
		          url: 'app/TOiR_request.php?func=showInfoUsedSpares',
		          reader: 
		          {
		            type: 'json',
		            root: 'rows'
		          }
		        }
});

Ext.define('ImageIconTOiR', {
    extend: 'Ext.data.Model',
    fields: [ { name:'src', type:'string' }]
});
var TOiR_imageStore = new Ext.data.Store( {
    id:'imagesStore_toir_id',
    model: 'ImageIconTOiR',
    proxy: {
	    type: 'ajax',		    
	    url: 'app/TOiR_request.php?func=showFoto',
        reader: {
            type: 'json',
            root: 'rows'
        }
    },
//autoLoad: true,	    
});


function showInfoAboutRequest(record) {
	TOiR_imageStore.load({
		params: {
			request_id: record.get('id')
		}
	});
	
	TOiR_RequestInfoJobStore.load({
		params: {
			request_id: record.get('id')
		}
	});	
	TOiR_RequestInfoConfirmationStore.load({
		params: {
		request_id: record.get('id')
		}
	});
	TOiR_RequestInfoEquipmentStore.load({
		params: {
			request_id: record.get('id')
			}
	});
	
	TOiR_RequestInfoUsedSparesStore.load({
		params: {
			request_id: record.get('id')
			}
	});
	
	console.log(record.get('id'));
	//var tabsname = ['Информация о работе', 'Подтверждения', 'Оборудование', 'Информация о запчастях'];
	var tabsname = [request_toir.information_about_the_work, request_toir.confirmation, TOiR.Equipment, request_toir.information_on_spare_parts];
	var firstTabPanel = new Ext.grid.Panel({
		selType: 'rowmodel',
	    columnLines: true,
	    id: 'TOiR_RequestGridFirstInfoId',
	    store: TOiR_RequestInfoJobStore,
	    loadMask: true,
	    border: false,
	    autoScroll: true,
	    columns:[{
	            	 text: 'ID',
	            	 dataIndex: 'id_request',
	            	 style: 'text-align:center',            
	                 align: 'center',
	                 width: 50,
	                 sortable: false,
	             }, {
	            	 //text: 'Результат работ',
					 text: request_toir.the_result_of_work,
	            	 dataIndex: 'id_result_job',
	            	 sortable: false,
	            	 width: 170,
	             }, {
	            	 //text: 'Комментарии',
					 text: request_toir.comments,
	            	 dataIndex: 'comment',
	            	 sortable: false,
	            	 width: 170,
	             }, {
	            	 //text: 'Возможная неисправность',
					 text: request_toir.possible_defects,
	            	 dataIndex: 'possible_fault',
	            	 sortable: false,
	            	 width: 170,
	             }, {
	            	 //text: 'Заключение мастера',
					 text: request_toir.conclusion_master,
	            	 dataIndex: 'conclution_master',
	            	 sortable: false,
	            	 width: 170,
	            	 
	             }/*, {
	            	 text: 'Превентив',
	            	 dataIndex: 'id_preventive',
	            	 sortable: false,
	             }*/
	             ]
	    
	});
	
	var imageTpl = new Ext.XTemplate(
		    '<tpl for=".">',
		        //'<div style="margin-bottom: 10px;" class="thumb-wrap">',
		        //'<div>',
		    	//'<span class="image" style="">',
		          '<img id="{src}" src="{src}" style="margin: 2px 2px 2px 2px;" width="100" height="70" class="image" />',		          
		        //'</div>',
		          //'</span>',
		    '</tpl>'
	);
	
	var imageView = new Ext.view.View({
		id: 'imageSelect_toir_id',
		/*mixins: {
	        dragSelector: 'Ext.ux.DataView.DragSelector',
	        draggable   : 'Ext.ux.DataView.Draggable'
	    },*/
		//border: 1,
		//draggable: true,
		store: TOiR_imageStore,
		//width: 400,
		autoScroll: true,
		autoRender: true,
	    tpl: imageTpl,	    
	    listeners: {
	    	itemclick: function (record, item, index, e, eOpts) {
	    		//console.log(record);
	    		var imagePath = item.data.src;
	    		console.log(index);
	    		/*if (flag) {	    					    		
		    		oldItem = item;		    		
	    			record.addItemCls(item, 'myclass');
	    			src = item.data.src;	    			
		    		flag = false;
	    		} */
	    		showBigpictureFromGrid(item.data.src);
	    	},
	    	beforeitemclick: function (record, item, index, e, eOpts ) {
	    		/*record.addItemCls(oldItem, 'myclass-none');	    		
	    		flag = true;*/
	    	}
	    },
	    
	    //itemSelector: 'img.image',
	    itemSelector: 'img',
	    emptyText: 'No images available',
	});
	
	var imagePanel = new Ext.panel.Panel({
		//title: 'Дополнительные фотографии',
		title: request_toir.additional_photos,
		//width: 200,
		//height: 200,
		//height: 150,
		//height: '50%',
		autoScroll: true,
		region:'center',
		//layout: 'fit',
		items: [imageView]
	});
	var secondTabPanelGrid = new Ext.grid.Panel({
		selType: 'rowmodel',
	    columnLines: true,
	    //height: 95,
	    
	   /* width: 200,
		height: 200,*/
	    //region:'north',
	    layout: 'fit',
	    id: 'TOiR_RequestGridSecondInfoId',
	    store: TOiR_RequestInfoConfirmationStore,
	    loadMask: true,
	    border: false,
	    autoScroll: true,
	    columns:[{
	            	 text: 'ID',
	            	 dataIndex: 'id_request',
	            	 style: 'text-align:center',            
	                 align: 'center',
	                 width: 50,
	                 sortable: false,
	             }, {
	            	 //text: 'Имя клиента',
					 text: request_toir.client_name,
	            	 dataIndex: 'name_client',
	            	 sortable: false,
	            	 width: 120,
	             }, {
	            	 //text: 'Должность',
					 text: request_toir.job_title,
	            	 dataIndex: 'post_client',
	            	 sortable: false,
	             }, {
	            	 //text: 'Подпись клиента',
					 text: request_toir.client_signature,
	            	 dataIndex: 'signature_client_img',
	            	 sortable: false,
	            	 width: 130,
	            	 listeners: {
	            		 click: function(grid) {
	            			 //console.log(grid.store.data.items[0].data.foto);	
	            			 showBigpictureFromGrid(grid.store.data.items[0].data.signature_client);
	            		 }
	            	 }
	             }, {
	            	 //text: 'Подпись мастера',
					 text: request_toir.master_signature,
	            	 dataIndex: 'signature_master_img',
	            	 sortable: false,
	            	 width: 150,
	            	 listeners: {
	            		 click: function(grid) {
	            			 //console.log(grid.store.data.items[0].data.foto);	
	            			 showBigpictureFromGrid(grid.store.data.items[0].data.signature_master);
	            		 }
	            	 }
	            	 
	             }, /*{
	            	 text: 'Фото',
	            	 dataIndex: 'foto_img',
	            	 sortable: false,
	            	 width: 150,
	            	 listeners: {
	            		 click: function(grid) {
	            			 //console.log(grid.store.data.items[0].data.foto);	
	            			 showBigpictureFromGrid(grid.store.data.items[0].data.foto);
	            		 }
	            	 }
	             }*/
	             
	             ]
	    
	});
	var panelForGrid =  new Ext.panel.Panel({
		//title: 'Info grid',
		region: 'north',
		height: 110,
		//width: '50%',
		border: true,
		//layout: 'border',
		items: [secondTabPanelGrid]
	});
	var secondTabPanel = new Ext.panel.Panel({
		layout: 'border',
		items: [panelForGrid, imagePanel]
	});
	
	var thirdTabPanel = new Ext.grid.Panel({
		selType: 'rowmodel',
	    columnLines: true,
	    id: 'TOiR_RequestGridthirdInfoId',
	    store: TOiR_RequestInfoEquipmentStore,
	    loadMask: true,
	    border: false,
	    autoScroll: true,
	    columns:[{
	            	 text: 'ID',
	            	 dataIndex: 'id_equipment',
	            	 style: 'text-align:center',            
	                 align: 'center',
	                 width: 50,
	                 sortable: false,
	             }, {
	            	 //text: 'Модель',
					 text: article_toir.model,
	            	 dataIndex: 'model',
	            	 sortable: false,
	            	 width: 170,
	             }, {
	            	 //text: 'Актуальная модель',
					 text: request_toir.current_model,
	            	 dataIndex: 'actual_model',
	            	 sortable: false,
	            	 width: 170,
	             }, {
	            	 //text: 'Актуальный номер',
					 text: request_toir.actual_number,
	            	 dataIndex: 'actual_number',
	            	 sortable: false,
	            	 width: 170,
	             }, {
	            	 //text: 'Счетчик',
					 text: equip_toir.counter,
	            	 dataIndex: 'count',
	            	 sortable: false,
	            	 width: 60,
	            	 
	             }, {
	            	 //text: 'Дата изменений',
					 text: request_toir.date_of_change,
	            	 dataIndex: 'changeTime',
	            	 sortable: false,
	            	 width: 170
	             }
	             ]
	    
	});
	
	var fourthTabPanel = new Ext.grid.Panel({
		selType: 'rowmodel',
	    columnLines: true,
	    id: 'TOiR_RequestGridfourthInfoId',
	    store: TOiR_RequestInfoUsedSparesStore,
	    loadMask: true,
	    border: false,
	    autoScroll: true,
	    columns:[/*{
	            	 text: '',
	            	 dataIndex: '',
	            	 style: 'text-align:center',            
	                 align: 'center',
	                 width: 50,
	                 sortable: false,
	             },*/ {
	            	 //text: 'Название',
					 text: outlet_toir.title,
	            	 dataIndex: 'name',
	            	 sortable: false,
	            	 width: 170,
	             }, {
	            	 //text: 'Группа запчастей',
					 text: request_toir.group_parts,
	            	 dataIndex: 'spares_group',
	            	 sortable: false,
	            	 width: 170,
	             }, {
	            	 //text: 'Артикул',
					 text: article_toir.article,
	            	 dataIndex: 'article',
	            	 sortable: false,
	            	 width: 150,
	             }, {
	            	 //text: 'Кол-во использовных',
					 text: request_toir.count_of_used,
	            	 dataIndex: 'count',
	            	 style: 'text-align:center',            
	                 align: 'center',
	            	 sortable: false,
	            	 width: 140,
	            	 
	             }, {
	            	 //text: 'Время установки',
					 text: request_toir.installation_time,
	            	 dataIndex: 'mobile_time_change',
	            	 sortable: false,
	            	 width: 170
	             }
	             ]
	    
	});
	
	var tabData = [firstTabPanel, secondTabPanel, thirdTabPanel, fourthTabPanel ];
	
	var tabpanel = Ext.create('Ext.tab.Panel', {
        resizeTabs: true,
        enableTabScroll: true,
		border:true,
		//itemId: 'tabPanelObject',
		id: 'tabPanelRequestInfo',
		frame:false,		
		//activeTab: 0,
        defaults: {
            //autoScroll: true,
            //bodyPadding: 5
        },
        items: []
	});
	
	for(i in tabsname){
		tabpanel.add({
            closable: false,
            //iconCls: 'tabs',
			layout: 'fit',
			autoScroll: false,
			floatable: false,
			align: 'stretch',
			defaults: { flex : 1 },
			border:false,
			id: 'infotab'+i,			
            title: tabsname[i],
			items: [tabData[i]]
        }).show();
	}
	
	if(!TOiR_request_RequestInfoWindow){
       TOiR_request_RequestInfoWindow = new Ext.Window({
                       width:800,
                       height:350,
                       //title: 'Информация о заявке',
					   title: request_toir.information_about_request,
                       closeAction : 'destroy',
						listeners : {
							destroy : function(){
								TOiR_request_RequestInfoWindow = null;	
							}
						},
                       layout:'fit',
                       resizable: true,
						constrainHeader: true,
                       modal:true,
                       items:[tabpanel]
       });
       TOiR_request_RequestInfoWindow.show();
       tabpanel.setActiveTab(0);
    }				
}

function showBigpictureFromGrid(imagePath) {
	 if(!TOiR_request_BigImageWindow && imagePath != null){
		 TOiR_request_BigImageWindow = new Ext.Window({
	                       width:800,
	                       height:600,
	                       modal: true,
	                       autoscroll: true,
	                       //title: 'Изображение',
	                       closeAction : 'destroy',
							listeners : {
								destroy : function(){
									TOiR_request_BigImageWindow = null;	
								}
							},
	                       layout:'fit',
	                       resizable: true,
						   constrainHeader: true,
	                       modal:true,
	                       items:[{
	                    	   html: '<img src="' + imagePath + '" width="800" height="600" >',
	                       }]
	       });
		 console.log(imagePath);
		 //if (imagePath != undefined) {
			 TOiR_request_BigImageWindow.show();	
		 //} 
		       
	    }   
}