var TOiR_spares_Window = null;
var selectUser = 0;
Ext.define('TOiR_SparesModel', {
    extend: 'Ext.data.Model',
    fields: ['id', 'user','spares_group','spare','aticle','count']
});
var TOiR_SparesStore = new Ext.data.Store(
  {
        //autoLoad: true,
		//autoDestroy: true,
		pageSize: 50,
		//remoteSort: true,		
		//simpleSortMode: true,
        model: 'TOiR_SparesModel',
        proxy: 
        {
          type: 'ajax',
          url: 'app/TOiR_spares.php?func=showData',
		  //url: 'app/test.php?func=show',
          reader: 
          {
            type: 'json',
            root: 'rows'
          }
        }
});
function show_TOiR_spares_Window(Xcoord,Ycoord,Wwidth,Wheight){
	
        
		Xcoord = Xcoord ? Xcoord :40;
        Ycoord = Ycoord ? Ycoord :60;  
        Wwidth = Wwidth ? Wwidth :700;  
        Wheight = Wheight ? Wheight :400;
    
    TOiR_SparesStore.setProxy({
		type: 'ajax',
          url: 'app/TOiR_spares.php?func=showData&selectUser='+selectUser,
		  //url: 'app/test.php?func=show',
          reader: 
          {
            type: 'json',
            root: 'rows'
          }
	});
	TOiR_SparesStore.load();
	TOiR_SparesStore.loadPage(1);


//TOiR_SparesStore.load();

Ext.define('TOiR_SparesUsersModel', {
    extend: 'Ext.data.Model',
    fields: ['id', 'name']
});

var TOiR_SparesUsersStore = new Ext.data.Store(
  {
        //autoLoad: true,
		//autoDestroy: true,		
        model: 'TOiR_SparesUsersModel',
        proxy: 
        {
          type: 'ajax',
          url: 'app/TOiR_spares.php?func=showUsers',
          reader: 
          {
            type: 'json',
            root: 'rows'
          }
        }
});
TOiR_SparesUsersStore.load();

/*Ext.define('TOiR_RolesModel', {
    extend: 'Ext.data.Model',
    fields: ['id', 'value']
});

var TOiR_UserStore = new Ext.data.Store(
  {
        autoLoad: true,
		autoDestroy: true,
        model: 'TOiR_UserModel',
        proxy: 
        {
          type: 'ajax',
          url: 'app/TOiR_users.php?func=show',
          reader: 
          {
            type: 'json',
            root: 'rows'
          }
        }
});*/
var PagingToolbarTOiR_spares = 	Ext.create('Ext.PagingToolbar', {
        //height:30,
        border: false,
        frame: false,
        store: TOiR_SparesStore,
        displayInfo: true
    });
	
    if (!TOiR_spares_Window){
        Ext.getBody().mask(all.loading);
        TOiR_spares_Window = new Ext.Window({
            layout : 'fit',
            //title : 'Запчасти',
			title : TOiR.spares,
            closeAction : 'destroy',
            width : parseInt(Wwidth),
            height : parseInt(Wheight),
            //minimizable: true,
			constrainHeader: true,
            maximizable:true,
            //x : parseInt(Xcoord),
            //y : parseInt(Ycoord),
			listeners : {
            	destroy : function(){
					TOiR_spares_Window = null;
					selectUser = 0;
            	}
            },
            items : [
			
new Ext.create('Ext.grid.Panel',{
    selType: 'rowmodel',
    columnLines: true,
    id: 'TOiR_SparesGridId',
    store: TOiR_SparesStore,
    loadMask: true,
    border: false,
    autoScroll: true,
	dockedItems: [{
            xtype: 'toolbar',
            items: [{
					xtype: 'combo',
					store: TOiR_SparesUsersStore,
					valueField: 'id',
					displayField: 'name',
					value: 0,
					listeners: {
						select: function(combo, records, eOpts) {						
						/*	console.log(records[0].get('id'))
							console.log(records.id);
							console.log(records);*/
							selectUser = records[0].get('id');
							var groupSparel = Ext.getCmp('group_sparel_id').getValue();
							var nameSparel = Ext.getCmp('sparel_name_id').getValue();
							TOiR_SparesStore.setProxy({
								type: 'ajax',
						          url: 'app/TOiR_spares.php?func=showData&groupSparel='+ groupSparel + '&nameSparel='+nameSparel+
						          '&selectUser='+selectUser,
								  //url: 'app/test.php?func=show',
						          reader: 
						          {
						            type: 'json',
						            root: 'rows'
						          }
							});
							TOiR_SparesStore.load(); 
							TOiR_SparesStore.loadPage(1);
							/*TOiR_SparesStore.load({
								params: {
									selectUser: selectUser
								}
							});*/
						}
					}					
				},
				,'-',{
					xtype: 'textfield',
					//emptyText: 'Группа запчастей',
					emptyText: request_toir.group_parts,
					id: 'group_sparel_id',
				} ,'-',{
					xtype: 'textfield',
					//emptyText: 'Название',
					emptyText: outlet_toir.title,
					id: 'sparel_name_id',
				} ,'-',{
					xtype: 'button',
					//text: 'Фильтровать',
					text: all_toir.filter,
					handler: function() {
						var groupSparel = Ext.getCmp('group_sparel_id').getValue();
						var nameSparel = Ext.getCmp('sparel_name_id').getValue();
						TOiR_SparesStore.setProxy({
							type: 'ajax',
					          url: 'app/TOiR_spares.php?func=showData&groupSparel='+ groupSparel + '&nameSparel='+nameSparel+
					          '&selectUser='+selectUser,
							  //url: 'app/test.php?func=show',
					          reader: 
					          {
					            type: 'json',
					            root: 'rows'
					          }
						});
						TOiR_SparesStore.load();
						TOiR_SparesStore.loadPage(1);
				        
						/*TOiR_SparesStore.load({
							params: {
								groupSparel: groupSparel,
								nameSparel: nameSparel
								
							}
						});*/
					}
				} ,'-',{
					xtype: 'button',
					//text: 'Очистить',
					text: all_toir.filter_reset,
					handler: function (){
						Ext.getCmp('group_sparel_id').setValue('');
						Ext.getCmp('sparel_name_id').setValue('');
						
						TOiR_SparesStore.setProxy({
							type: 'ajax',
					          url: 'app/TOiR_spares.php?func=showData&selectUser='+selectUser,
							  //url: 'app/test.php?func=show',
					          reader: 
					          {
					            type: 'json',
					            root: 'rows'
					          }
						});
						TOiR_SparesStore.load();
						TOiR_SparesStore.loadPage(1);
						
						/*TOiR_SparesStore.load({
							params: {
								groupSparel: '',
								nameSparel: ''
								
							}
						});*/
					}
				} 
			]
	}],
    columns:[
      {
        //text: 'Ремонтная бригада', 
		text: spares_toir.repair_brigade, 
        dataIndex: 'user',
        sortable: true,
		width: 150,
      },
      {
        //text: 'Группа запчастей', 
		text: request_toir.group_parts, 
        dataIndex: 'spares_group',        
        sortable: true,
		width: 120,
      },
      {
        //text: 'Запчасть', 
		text: spares_toir.spare_part, 
        dataIndex: 'spare',
        sortable: true
      },
      {
        //text: 'Артикул', 
		text: article_toir.article,
        dataIndex: 'aticle',
        sortable: true
      },
      {
        //text: 'Количество', 
		text: spares_toir.amount, 
        dataIndex: 'count',
        sortable: true
      }
    ], 
		bbar:[PagingToolbarTOiR_spares],
})
			]
        });
        
    }
    
    TOiR_spares_Window.show();
    Ext.getBody().unmask(all.loading);
	
}